#!/usr/bin/env python
# -*- coding: UTF-8 -*-
# Copyright 2014
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import urllib,urllib2,re,xbmcplugin,xbmcgui,xbmc,xbmcaddon,HTMLParser,sys
from tools import *
from xbmcgui import ListItem
from BeautifulSoup import BeautifulSoup

versao = '0.0.1'
addon_id = 'plugin.audio.playcds'
selfAddon = xbmcaddon.Addon(id=addon_id)
addonfolder = selfAddon.getAddonInfo('path')
artfolder = addonfolder + '/resources/img/'
fanart = addonfolder + '/fanart.jpg'

def Menu_Principal():
	addDir('Categorias','-',1,artfolder + 'categorias.jpg')
	addDir('Atualizações','http://www.playcds.com.br/atualizacao.php',2,'atualizacao.png')
	addDir('Artistas','http://www.playcds.com.br/topartista.php',6,artfolder + 'topartista.jpg')
	addDir('Mais Acessados','http://www.playcds.com.br/topcds.php',2,artfolder + 'topcds.jpg')


def Categorias():
    addDir('Axe','http://www.playcds.com.br/estilo.php?letra=Axe',6,artfolder + 'Axe.jpg')
    addDir('Country','http://www.playcds.com.br/estilo.php?letra=Country',6,artfolder + 'Country.jpg')
    addDir('Eletronica','http://www.playcds.com.br/estilo.php?letra=Eletr%F4nica',6,artfolder + 'Eletronica.jpg')
    addDir('Forro','http://www.playcds.com.br/estilo.php?letra=Forro',6,artfolder + 'Forro.jpg')
    addDir('Hard Rock','http://www.playcds.com.br/estilo.php?letra=Hard%20Rock',6,artfolder + 'Hard_Rock.jpg')
    addDir('Hip Hop','http://www.playcds.com.br/estilo.php?letra=Hip%20Hop',6,artfolder + 'Hip_Hop.jpg')
    addDir('MPB','http://www.playcds.com.br/estilo.php?letra=MPB',6,artfolder + 'MPB.jpg')
    addDir('Pagode','http://www.playcds.com.br/estilo.php?letra=Pagode',6,artfolder + 'Pagode.jpg')
    addDir('Pop','http://www.playcds.com.br/estilo.php?letra=Pop',6,artfolder + 'Pop.jpg')
    addDir('Reggae','http://www.playcds.com.br/estilo.php?letra=Reggae',6,artfolder + 'Reggae.jpg')
    addDir('Rock','http://www.playcds.com.br/estilo.php?letra=Rock',6,artfolder + 'Rock.jpg')
    addDir('Romantico','http://www.playcds.com.br/estilo.php?letra=Romantico',6,artfolder + 'Romantico.jpg')
    addDir('Samba','http://www.playcds.com.br/estilo.php?letra=Samba',6,artfolder + 'Samba.jpg')
    addDir('Sertanejo','http://www.playcds.com.br/estilo.php?letra=Sertanejo',6,artfolder + 'Sertanejo.jpg')
    addDir('Trilha Sonora','http://www.playcds.com.br/estilo.php?letra=Trilha%20Sonora',6,artfolder + 'Trilha_Sonora.jpg')


def listar_albums(url):
	a = []
	codigo_fonte = abrir_url(url)
	soup = BeautifulSoup(abrir_url(url))
	content = BeautifulSoup(soup.find("div", { "id" : "meiodentro" }).prettify())
	resultados = content.findAll("td",  { "width" : "1%" })
	for resultado in resultados:
		temp = [resultado.a["href"],"%s" % (resultado.text.encode('ascii', 'ignore')),resultado.img["src"]] 
		a.append(temp)
	total = len(a)
	
	for url2, titulo, img in a:
		titulo = cleanHtml(titulo)
		addDir(titulo,url2,4,img,False,total,'')

def listar_albums_artista(url):
	a = []
	codigo_fonte = abrir_url(url)
	soup = BeautifulSoup(abrir_url(url))
	content = BeautifulSoup(soup.find("div", { "id" : "meiodentro" }).prettify())
	resultados = content.findAll("td",  { "width" : "1%" })
	for resultado in resultados:
		temp = [resultado.a["href"],"%s" % (resultado.text.encode('ascii', 'ignore')),resultado.img["src"]] 
		a.append(temp)
	total = len(a)
	
	for url2, titulo, img in a:
		titulo = cleanHtml(titulo.replace("-"," "))
		addDir(titulo,'http://www.playcds.com.br/'+url2,2,img,True,total,'')

def listar_musicas(url):
	progress = xbmcgui.DialogProgress()
	progress.create("PlayCds", "Gerando a playlist...")
	progress.update(0)
	playlist = xbmc.PlayList(1)
	playlist.clear()
	album_id = re.findall(r'album=([0-9]*?)&',url)[0]
	xml_url = 'http://www.playcds.com.br/tocartodas.php?cd_codigo=' + album_id
	soup = BeautifulSoup(abrir_url(xml_url))
	musicas = soup.findAll("track")
	n = 0
	for musica in musicas:
		print musica
		if musica.location:
			liz=xbmcgui.ListItem(musica.creator.text, iconImage=musica.image.text, thumbnailImage=musica.image.text)
			n=n+1
			liz.setInfo('music', {'Title':musica.creator.text,'Album':musica.title.text.replace("CD:",""),'Artist':'','Year':''})
			liz.setProperty('mimetype', 'audio/mpeg')
			playlist.add(musica.location.text, liz)
			progress_ = len(playlist) / float(len(musicas)) * 100
			progress.update(int(progress_))

		if progress.iscanceled():
			return
	xbmcPlayer = xbmc.Player(xbmc.PLAYER_CORE_AUTO)
	xbmcPlayer.play(playlist)


################################################
#    Funções relacionadas a media.             #
#                                              #
################################################

def addLink(name,url,iconimage):
	ok=True
	liz=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
	liz.setProperty('fanart_image', fanart)
	liz.setInfo( type="Video", infoLabels={ "Title": name } )
	ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=url,listitem=liz)
	return ok

def addDir(name,url,mode,iconimage,pasta=True,total=1,plot=''):
	u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
	ok=True
	liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
	liz.setProperty('fanart_image', fanart)
	liz.setInfo( type="video", infoLabels={ "title": name, "plot": plot } )
	ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=pasta,totalItems=total)
	return ok



################################################
#    Pega os parametros                        #
#                                              #
################################################

def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param

      
params=get_params()
url=None
name=None
mode=None
iconimage=None


try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass

try:        
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass


print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "Iconimage: "+str(iconimage)

################################################
#    Destina para cada modo.                   #
#                                              #
################################################

if mode==None or url==None or len(url)<1:
        print "Sem mode"
        print "Inicio: Menu Principal"
        Menu_Principal()

elif mode==1:
	print "Mode: 1 - Categorias"
	Categorias()
	
elif mode==2:
	print "Mode: 2 - Listar Albums"
	listar_albums(url)
	
elif mode==3:
	print "Mode: 3"
	listar_albums(url)

elif mode==4:
	print "Mode: 4 - Listar Musicas"
	listar_musicas(url)

elif mode==6:
	print 'Mode: 6'
	listar_albums_artista(url)
	
xbmcplugin.endOfDirectory(int(sys.argv[1]))